/*
 * Pair.h
 *
 *  Created on: Oct 7, 2008
 *      Author: bloch
 */

#ifndef PAIR_H_
#define PAIR_H_

#include <iostream>

class Pair {
private:
	int x, y;
public:
	Pair(int xarg=0, int yarg=0);
	virtual ~Pair();
	int getX() const { return x; }
	int getY() const { return y; }

	const Pair& operator= (const Pair& other) {
		if (this != &other) {
			this->x = other.x;
			this->y = other.y;
		}
		return *this;
	}

	bool operator== (const Pair& other) {
		return this->x==other.x && this->y==other.y;
	}

	bool operator!= (const Pair& other) {
		return ! (*this == other);
	}

	const Pair& operator+= (const Pair& other) {
		this->x += other.x;
		this->y += other.y;
		return *this;
	}
};

std::ostream& operator<< (std::ostream&s, const Pair & thisPair);
#endif /* PAIR_H_ */
